BEGIN {
  if (mode != "check") {
    if (mode != "change") {
      print "mode not correct";
      exit;
    }
  }
  # looking for switch ... case ... {
  # switchState may takes one of the next values
  normalLine        = 0;
  switchIsFound     = 1;
  caseIsFound       = 2;
  defaultIsFound    = 3;
  leftBraceIsFound  = 4;
  endOfBlockIsFound = 5;
  leftBrace  = "{";
  rightBrace = "}";
  fourSpace = "    ";
#
  switchState = normalLine;
  testIt = "no";
  #testIt = "yes";
  testIt_f = "no";
  #testIt_f = "yes";
}
function FirstSpaceAway(inLine,    i, lengthOfTheInLine, character, firstPLace, outLine)
{                              # separate local variables from real  parameters  by  extra  spaces
  # looking for first not space character
  lengthOfTheInLine = length(inLine);
  for (i = 1; i <= lengthOfTheInLine; i++) {
    character = substr(inLine, i, 1);
    if (character != " ") {
      firstPLace = i;
      break;
    }
  }
  outLine = substr(inLine, firstPLace);
  return outLine;
}
function RIndex(inLine,whatChar,    i, lengthOfTheInLine, character, lastPLace)
{                              # separate local variables from real  parameters  by  extra  spaces
  # looking for first "whatChar" character back from the end of the string "inLine"
  lengthOfTheInLine = length(inLine);
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  lastPlace = 0;
  for (i = lengthOfTheInLine; i >= 1; i--) {
    character = substr(inLine, i, 1);
    if (character == whatChar) {
      lastPlace = i;
      break;
    }
  }
  return lastPlace;
}
function LookForPunkt(inLine,      lengthOfTheInLine, character, whereIsPunkt)
{                                # separate local variables from real  parameters  by  extra  spaces
  # look for : after case or default
  lengthOfTheInLine = length(inLine);
  if (lengthOfTheInLine == 0) {
    return 0;
  }
  character = substr(inLine, lengthOfTheInLine, 1);
  if (character == ":") {
    return lengthOfTheInLine;
  } else {
    if (testIt == "yes") {
      printf("look back to the :\n");
    }
    # look back to the :
    whereIsPunkt = RIndex(inLine, ":");
    if (whereIsPunkt > 0) {
      return whereIsPunkt;
    } else {
      return 0;
    }
  }
}
function PutIndentation(lengthOfIndentation,          i)
{                                # separate local variables from real  parameters  by  extra  spaces
  indentation = "";
  for (i = 1; i<= lengthOfIndentation; i++) {
    indentation = sprintf("%s ", indentation);
  }
}
function PutOldLine(oneOldLine, what)
{
  # increment the buffer with one line. what is a debug variable
  oldLineNR = oldLineNR + 1;
  theOldLines[oldLineNR] = oneOldLine;
  whatOldLines[oldLineNR] = what;
}
function GetOldLine()
{
  # decrement the buffer with one line.
  saveTheLine = theOldLines[oldLineNR];
  oldLineNR = oldLineNR - 1;
  return saveTheLine;
}
function FlushTheOldLines(where,               i)
{                                # separate local variables from real  parameters  by  extra  spaces
  
  # indentation, oldLineNR, theOldLines, whatOldLines are global variables
  if (oldLineNR > 0) {
    # old line(s) is/are present
    for (i = 1; i <= oldLineNR ; i++) {
      if (testIt_f == "yes") {
        printf("f-Normal[%d](%d)(%d)=", i, where, whatOldLines[i]);
      }
      if (testIt == "yes") {
        printf("%d============================", whatOldLines[i]);
      }
      printf("%s%s\n", indentation, theOldLines[i]);
    }
  } else {
    if (testIt_f == "yes") {
      printf("f-Normal(%d)=nothing\n", where);
    }
  }
  # init the buffer
  oldLineNR = 0;
}
# =============================================================================================
{
  theLine= $0;
  if (testIt == "yes") {
    printf("\nZeile %d >>%s<<\n", NR, theLine);
  }
  theOutLine = FirstSpaceAway(theLine);

  if (testIt == "yes") {
    printf("switchState(0)(%d)=%d\n", NR, switchState);
  }
  switch(switchState) {
  case 0: # normalLine:
    # look for switch [1]
    whereIsSwitch = index(theOutLine, "switch (");
    if (whereIsSwitch == 1) {
      if (testIt == "yes") {
        printf("switchState(1)(%d)=%d, changed to %d\n", NR, switchState, switchIsFound);
      }
      switchState = switchIsFound;
      blockNumber = 0;
      whereIsSwitch2 = index(theLine, "switch (");
      lengthOfBeforeSwitch = whereIsSwitch2 - 1;
      # build the indentation
      PutIndentation(lengthOfBeforeSwitch);
      if (testIt == "yes") {
        printf("switch found(1), NR=%d\n", NR);
      }
    }
    if (mode == "change") {
      if (testIt == "yes") {
        printf("n-Normal(1)====================");
      }
      printf("%s\n", theLine);
    }
    break;
  case 1: # switchIsFound
    # look for case [2]
    whereIsCase = index(theOutLine, "case ");
    if (whereIsCase == 1) {
      # init the buffer
      oldLineNR = 0;
      if (testIt == "yes") {
        printf("case found(1), NR=%d\n", NR);
      }
      if (mode == "check") {
        theOldLine = theLine;
      }
      if (mode == "change") {
        breakAfterBlockFound = "no";
        PutOldLine(theOutLine, 165)
      }
      if (testIt == "yes") {
        printf("switchState(2)(%d)=%d, changed to %d\n", NR, switchState, caseIsFound);
      }
      switchState = caseIsFound;
    } else {
      # look for default [3]
      whereIsDefault = index(theOutLine, "default");
      if (whereIsDefault == 1) {
        if ( testIt == "yes") {
          printf("default found(1), NR=%d\n", NR);
        }
        if (mode == "check") {
          theOldLine = theLine;
        }
        if (mode == "change") {
          PutOldLine(theOutLine, 182)
        }
        if (testIt == "yes") {
          printf("switchState(3)(%d)=%d, changed to %d\n", NR, switchState, defaultIsFound);
        }
        switchState = defaultIsFound;
      } else {
        # look for rightBrace [4]
        whereIsRightBrace = index(theOutLine, rightBrace);
        if (whereIsRightBrace == 1) {
          if (mode == "change") {
            PutOldLine(theOutLine, 199)
            FlushTheOldLines(200);
            if (testIt == "yes") {
              printf("switchState(4)(%d)=%d\n", NR, switchState);
            }
          }
          if (blockNumber == 1) {
            switchState = normalLine;
          }
    #      blockNumber = blockNumber - 1;
    #      if (testIt == "yes") {
    #        printf("rightBrace found(1), NR=%d >>%s<<, blockNumber=%d\n", NR, theLine, blockNumber);
    #      }
        } else {
          if (testIt == "yes") {
            printf("switchState(5)(%d)=%d\n", NR, switchState);
          }
          if (mode == "change") {
            FlushTheOldLines(2);
            if (testIt == "yes") {
              printf("n-Normal(2b)=");
            }
            printf("%s\n", theLine);
          }
        }
      }
    }
    switch(switchState) {
    case 2: # caseIsFound
    case 3: # defaultIsFound
      if (testIt == "yes") {
        printf("look for leftBrace after case or default at the same line\n");
      }
      # look for leftBrace after case or default
      whereIsPunkt = LookForPunkt(theOutLine);
      if (whereIsPunkt > 0) {
        if (testIt == "yes") {
          printf(": found(1) at %d, NR=%d\n", whereIsPunkt, NR);
        }
        lengthOfTheInLine = length(theOutLine);
        if (testIt == "yes") {
          printf("lengthOfTheInLine= %d\n", lengthOfTheInLine);
        }
        if (whereIsPunkt != lengthOfTheInLine) {
          # look for leftBrace [7a]
          whereIsleftBrace = index(theOutLine, leftBrace);
          if (whereIsleftBrace > 0) {
            blockNumber = blockNumber + 1;
            endOfBlockFound = "no";
            if (testIt == "yes") {
              printf("leftBrace found(1), NR=%d, ********************************blockNumber=%d\n", NR, blockNumber);
            }
            if (testIt == "yes") {
              printf("switchState(6)(%d)=%d, changed to %d\n", NR, switchState, leftBraceIsFound);
            }
            switchState = leftBraceIsFound;
          } else {
            if (testIt == "yes") {
              printf("NO leftBrace found(2), NR=%d\n", NR);
            }
          }
        } else {
          if (testIt == "yes") {
            printf("NO leftBrace found(3), NR=%d\n", NR);
          }
          ## NO ## FlushTheOldLines(3);
        }
      } else {
        if (testIt == "yes") {
          printf("NO leftBrace found(4), NR=%d\n", NR);
        }
      }
      break;
    }
    break;
  case 2: # caseIsFound
  case 3: # defaultIsFound
    # look for default [6]
    whereIsDefault = index(theOutLine, "default");
    if (whereIsDefault == 1) {
      if (testIt == "yes") {
        printf("default found(2), NR=%d\n", NR);
      }
      if (mode == "check") {
        theOldLine = theLine;
      }
      if (mode == "change") {
        PutOldLine(theOutLine, 273)
      }
      if (testIt == "yes") {
        printf("switchState(7)(%d)=%d, changed to %d\n", NR, switchState, defaultIsFound);
      }
      switchState = defaultIsFound;
    } else {
      # look for a new case [5]
      whereIsCase = index(theOutLine, "case ");
      if (whereIsCase == 1) {
        if (testIt == "yes") {
          printf("case found(2), NR=%d\n", NR);
        }
        if (mode == "check") {
          theOldLine = theLine;
        }
        if (mode == "change") {
          PutOldLine(theOutLine, 292)
        }
        if (testIt == "yes") {
          printf("switchState(8)(%d)=%d, changed to %d\n", NR, switchState, caseIsFound);
        }
        switchState = caseIsFound;
      } else {
        # look for rightBrace [9]
        whereIsRightBrace = index(theOutLine, rightBrace);
        if (whereIsRightBrace == 1) {
          if (blockNumber == 1) {
            if (testIt == "yes") {
              printf("switchState(9)(%d)=%d, changed to %d\n", NR, switchState, normalLine);
            }
            switchState = normalLine;
          }
          blockNumber = blockNumber - 1;
          if (testIt == "yes") {
            printf("rightBrace found(2), NR=%d >>%s<<, ********************************blockNumber=%d\n", NR, theLine, blockNumber);
          }
          if (mode == "change") {
            PutOldLine(theOutLine, 320)
            FlushTheOldLines(321);
          }
        } else {
          # look for break [8]
          whereIsBreak = index(theOutLine, "break");
          if (whereIsBreak == 1) {
            if (testIt == "yes") {
              printf("break found(1), NR=%d\n", NR);
            }
            if (mode == "change") {
              # prepare the line
              theOutLine = fourSpace "break;";
              PutOldLine(theOutLine, 318)
              FlushTheOldLines(319);
            }
            if (testIt == "yes") {
              printf("switchState(10)(%d)=%d, changed to %d\n", NR, switchState, switchIsFound);
            }
            switchState = switchIsFound;
          } else {
            if (testIt == "yes") {
              printf("look for leftBrace after case or default at the next line\n");
            }
            # look for leftBrace [7b]
            whereIsleftBrace = index(theOutLine, leftBrace);
            if (whereIsleftBrace == 1) {
              blockNumber = blockNumber + 1;
              if (testIt == "yes") {
                printf("leftBrace found(5), NR=%d >>%s<<, ********************************blockNumber=%d\n", NR, theLine, blockNumber);
              }
              if (testIt == "yes") {
                printf("switchState(11)(%d)=%d, changed to %d\n", NR, switchState, leftBraceIsFound);
              }
              switchState = leftBraceIsFound;
              # left brace found at the next line
              # the left brace should be placed at the end of the line before
              if (mode == "check") {
                printf( "%d:%s\n", NR - 1, theOldLine);
                printf( "%d:%s\n", NR, theLine);
                printf( "left brace found at the next line\n");
                printf( "the left brace should be placed at the end of the line before\n");
              }
              if (mode == "change") {
                # prepare the line
                theOutLine = GetOldLine() " " leftBrace;
                if (testIt == "yes") {
                  printf( "the new Line:%s\n", theOutLine);
                }
                PutOldLine(theOutLine, 352)
                FlushTheOldLines(4);
              }
            } else {
              # other statment(s) [10]
              if (mode == "change") {
                # prepare the line
                theOutLine = FirstSpaceAway(theLine);
                theOutLine = fourSpace theOutLine;
                PutOldLine(theOutLine, 360)
                FlushTheOldLines(5);
              }
            }
          }
        }
      }
    }
    break;
  case 4: # leftBraceIsFound
    if (testIt == "yes") {
      printf("a new Block\n");
    }
    if (testIt == "yes") {
      printf("switchState(12)(%d)=%d\n", NR, switchState);
    }
    # look for rightBrace [11]
    whereIsRightBrace = index(theOutLine, rightBrace);
    if (whereIsRightBrace == 1) {
      if (blockNumber == 1) {
        if (testIt == "yes") {
          printf("switchState(13)(%d)=%d, changed to %d\n", NR, switchState, endOfBlockIsFound);
        }
        switchState = endOfBlockIsFound;
        endOfBlockFound = "yes";
        # test the indentation
        whereIsRightBrace = index(theLine, rightBrace);
        if (testIt == "yes") {
          printf("rightBrace at %d, end of Block found(2), NR=%d\n", whereIsRightBrace, NR);
          printf("lengthOfBeforeSwitch(2)=%d\n", lengthOfBeforeSwitch);
        }
      }
      blockNumber = blockNumber - 1;
      if (testIt == "yes") {
        printf("rightBrace at %d, end of Block found(1), NR=%d, ********************************blockNumber=%d\n", whereIsRightBrace, NR, blockNumber);
      }
      if (mode == "check") {
        theOldLine = theLine;
        if (whereIsRightBrace - 1 > lengthOfBeforeSwitch) {
          printf("%d:%s\n", NR, theLine);
          printf("indentation is too big, should be %d\n", lengthOfBeforeSwitch);
        }
      }
      if (mode == "change") {
        if (testIt == "yes") {
          printf("breakAfterBlockFound at 403:%s\n", breakAfterBlockFound);
        }
        if (breakAfterBlockFound == "no") {
          PutOldLine(rightBrace, 406)
        }
      }
    } else {
      # other statment(s) [12]
      # here!!
      # look for leftBrace [], maybe a "if" command
      whereIsleftBrace = index(theOutLine, leftBrace);
      if (whereIsleftBrace > 0) {
        blockNumber = blockNumber + 1;
        if (testIt == "yes") {
          printf("leftBrace found(6), NR=%d, ********************************blockNumber=%d\n", NR, blockNumber);
        }
      }
      if (mode == "change") {
        # prepare the line
        theOutLine = FirstSpaceAway(theLine);
        theOutLine = fourSpace theOutLine;
        PutOldLine(theOutLine, 414)
        FlushTheOldLines(7);
      }
    }
    break;
  case 5: # endOfBlockIsFound
    if (testIt == "yes") {
      printf("(5),NR=%d:%s\n", NR, theOutLine);
    }
    breakAfterBlockFound = "no";
    # look for break [13]
    whereIsBreak = index(theOutLine, "break");
    if (whereIsBreak == 1) {
      breakAfterBlockFound = "yes";
      if (testIt == "yes") {
        printf("breakAfterBlockFound at 430:%s\n", breakAfterBlockFound);
      }
      if (mode == "check") {
        printf( "%d:%s\n", NR - 1, theOldLine);
        printf( "%d:%s\n", NR, theLine);
        printf("break after a block found, NR=%d\n", NR);
        printf( "the break should be placed before the end of the block\n");
      }
      if (mode == "change") {
        if (testIt == "yes") {
          printf("Changed(3),NR=%d:\n", NR);
        }
        # a line we don't need
        temp = GetOldLine();
        PutOldLine("    break;", 444)
        PutOldLine(rightBrace, 445)
        FlushTheOldLines(446);
        #breakAfterBlockFound = "no";
      }
      if (testIt == "yes") {
        printf("switchState(15)(%d)=%d, changed to %d\n", NR, switchState, switchIsFound);
      }
      switchState = switchIsFound;
    } else {
      # look for case [14]
      whereIsCase = index(theOutLine, "case ");
      if (whereIsCase == 1) {
        if (testIt == "yes") {
          printf("case after end of block found(2), NR=%d:%s\n", NR, theLine);
        }
        if (mode == "check") {
          theOldLine = theLine;
        }
        if (mode == "change") {
          PutOldLine(theOutLine, 464)
        }
        if (testIt == "yes") {
          printf("switchState(16)(%d)=%d, changed to %d\n", NR, switchState, caseIsFound);
        }
        switchState = caseIsFound;
      } else {
        # look for default [15]
        whereIsDefault = index(theOutLine, "default");
        if (whereIsDefault == 1) {
          if ( testIt == "yes") {
            printf("default after a block found(1), NR=%d\n", NR);
          }
          if (mode == "check") {
            theOldLine = theLine;
          }
          if (mode == "change") {
            PutOldLine(theOutLine, 481)
          }
          if (testIt == "yes") {
            printf("switchState(17)(%d)=%d, changed to %d\n", NR, switchState, defaultIsFound);
          }
          switchState = defaultIsFound;
        } else {
          # look for rightBrace, end of Block [16]
          whereIsRightBrace = index(theOutLine, rightBrace);
          if (whereIsRightBrace == 1) {
            blockNumber = blockNumber - 1;
            if (testIt == "yes") {
              printf("rightBrace found, end of switch(527), NR=%d, ********************************blockNumber=%d\n", NR, blockNumber);
            }
            if (blockNumber == 1) {
              if (testIt == "yes") {
                printf("switchState(19)(%d)=%d, changed to %d\n", NR, switchState, normalLine);
              }
              switchState = normalLine;
            }
            if (mode == "change") {
              tempOutLine = rightBrace;
              if (testIt == "yes") {
                printf("the tempOutLine at 501:%s\n", tempOutLine);
              }
              PutOldLine(tempOutLine, 503)
              FlushTheOldLines(560);
            }
          } # if (whereIsRightBrace == 1)
        }
      }
    }
    break;
  } # switch(switchState)
}
