BEGIN {
  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  leftBrace  = "{";
  rightBrace = "}";

  switchState = normalLine;
  testIt ="no";
  #testIt ="yes";
}
{
  theLine = $0;
  if (testIt == "yes") {
    printf("\n%d, ====>:%s:\n", NR, theLine);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";
  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("switchState(49)(%d)=%d\n", NR, switchState);
    }
    switch(switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = index(restOfTheLine, "/*");
      if (testIt == "yes") {
        printf("whereIsComment_1= %d\n", whereIsComment_1);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        # [1]
        if (testIt == "yes") {
          printf("switchState(62)(%d) changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(67)partBeforeComment >>%s<<\n", partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(71)workLine >>%s<<:\n", workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("%d:(77)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("whereIsComment_2= %d\n", whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("switchState(87)(%d) changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          # remove space(s) at end of the line
          lengthOfThePartBefore = length(partBeforeComment);
          letter = substr(partBeforeComment, lengthOfThePartBefore, 1);
          while (letter == " ") {
            tempBuffer = substr(partBeforeComment, 1, lengthOfThePartBefore- 1);
            partBeforeComment = tempBuffer;
            lengthOfThePartBefore = length(partBeforeComment);
            letter = substr(partBeforeComment, lengthOfThePartBefore, 1);
          }
          if (testIt == "yes") {
            printf("(92)partBeforeComment >>%s<<\n", partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(96)workLine >>%s<<:\n", workLine);
          }
        } else {
          whereIsString_1 =  index(restOfTheLine, "\"");
          if (testIt == "yes") {
            printf("whereIsString_1= %d\n",  whereIsString_1);
          }
          if (whereIsString_1 > 0) {
            # []
            if (testIt == "yes") {
              printf("switchState(115)(%d) changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(120)partBeforeString >>%s<<\n", partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(124)workLine >>%s<<:\n", workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("%d:(130)restOfTheLine >>%s<<\n", NR, restOfTheLine);
            }
          } else {
            whereIsString_2 =  index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("whereIsString_2= %d\n",  whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("switchState(140)(%d) changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(145)partBeforeString >>%s<<\n", partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(149)workLine >>%s<<:\n", workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("%d:(155)restOfTheLine >>%s<<\n", NR, restOfTheLine);
              }
            } else {
              whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("whereIsDirective= %d\n", whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("switchState(166)(%d) changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("%d:(176)restOfTheLine >>%s<<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(138)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("switchState(145)(%d) changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(152)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(159)workLine >>%s<<:\n", workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(164)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(172)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("switchState(180)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(201)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for "
      whereIsStringEnd = index(restOfTheLine, "\"");
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(208)(%d) changed to string_1_EndIsFound\n", NR);
        }
        switchState = string_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(215)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(222)workLine >>%s<<:\n", workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(227)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(231)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(256)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for '
      whereIsStringEnd = index(restOfTheLine, "'");
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(263)(%d) changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(270)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(277)workLine >>%s<<:\n", workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(282)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(286)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("%d:(307)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("switchState(315)(%d) changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    } # switch(switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(nach while)workLine >>%s<<\n", workLine);
  }
  #
  tryFound = index(workLine, " try");
  if (tryFound > 0) {
    lengthOfWorkLine = length(workLine);
    letter = substr(workLine, lengthOfWorkLine, 1);
    problem = "no";
    if (letter != leftBrace) {
      if (testIt == "yes") {
        printf("%d: tryFound=%d\n", NR, tryFound);
        printf("%d: lengthOfWorkLine=%d\n", NR, lengthOfWorkLine);
      }
      if (lengthOfWorkLine > tryFound + 4) {
        letterAfterTry = substr(workLine, tryFound + 5, 1);
        if (testIt == "yes") {
          printf("%s: letterAfterTry =%d\n", NR, letterAfterTry);
        }
        if (letterAfterTry != " ") {
           # OK 
           problem = "no";
        } else {
           problem = "yes";
        }
      }
      if ( problem == "yes") {
        printf( "%d: try without leftBrace at end of line: %s\n", NR, theLine);
      }
    }
  }
  #
  catchFound = index(workLine, "catch");
  if (catchFound > 0) {
    lengthOfWorkLine = length(workLine);
    letter = substr(workLine, lengthOfWorkLine, 1);
    if (letter != leftBrace) {
      printf( "%d: case without leftBrace at end of line: %s\n", NR, theLine);
    }
  }
}
